( cd usr/bin ; rm -rf crictl )
( cd usr/bin ; ln -sf /usr/bin/k3s crictl )
( cd usr/bin ; rm -rf ctr )
( cd usr/bin ; ln -sf /usr/bin/k3s ctr )
( cd usr/bin ; rm -rf kubectl )
( cd usr/bin ; ln -sf /usr/bin/k3s kubectl )

config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}
preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

preserve_perms etc/rc.d/rc.k3s.new
config etc/rancher/k3s/k3s.service.env.new

if [ ! -f /etc/rancher/k3s/k3s.yaml ]; then
  k3s server \
    --write-kubeconfig /etc/rancher/k3s/k3s.yaml \
    --write-kubeconfig-mode 644 > /dev/null 2>&1 &
fi
